#include "bsp_gpio.h"
#include "delay_redefine.h"

bsp_io_level_t PinRead(ioport_ctrl_t * const p_ctrl, bsp_io_port_pin_t pin)
{
		bsp_io_level_t Pin_value;
		R_IOPORT_PinRead(p_ctrl, pin, &Pin_value);
		return Pin_value;
}

/* GPIO初始化函数 */
void GPIO_Init(void)
{
    /* 初始化配置引脚（这里其实重复初始化了，可以注释掉） */
    R_IOPORT_Open (&g_ioport_ctrl, g_ioport.p_cfg);
}


//mode:0,不支持连续按;1,支持连续按;
//0，没有任何按键按下
//2，KEY1按下
//3，KEY2按下 
//注意此函数有响应优先级,KEY1>KEY2
uint8_t Key_Scan(uint8_t mode)
{	 
	static uint8_t key_up=1;//按键按松开标志
	if(mode)key_up=1;  //支持连按		  
	if(key_up&&(KEY1_READ==0||KEY2_READ==0))
	{
		delay_ms(10);//去抖动 
		key_up=0;
		if(KEY1_READ==0)return 1;
		else if(KEY2_READ==0)return 2;
	}else if(KEY1_READ==1&&KEY2_READ==1)key_up=1; 	    
 	return 0;// 无按键按下
}