#include "hal_data.h"

/* 
		SCL引脚设置推挽输出
		SDA引脚模式设置,开漏输出,上拉, 这样就不用再设置IO方向了, 开漏输出的时候(=1), 也可以读取外部信号的高低电平 
*/

/* 引脚置低电平 */
#define LED_ON      R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_01, BSP_IO_LEVEL_LOW)
#define SCL_LOW     R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_04_PIN_00, BSP_IO_LEVEL_LOW)
#define SDA_LOW     R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_04_PIN_01, BSP_IO_LEVEL_LOW)

/* 引脚置高电平 */
#define LED_OFF     R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_01, BSP_IO_LEVEL_HIGH)
#define SCL_HIGH    R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_04_PIN_00, BSP_IO_LEVEL_HIGH)
#define SDA_HIGH    R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_04_PIN_01, BSP_IO_LEVEL_HIGH)

bsp_io_level_t PinRead(ioport_ctrl_t * const p_ctrl, bsp_io_port_pin_t pin);

/* 两个按键引脚定义 */
#define KEY1_SW1_PIN    BSP_IO_PORT_09_PIN_14
#define KEY2_SW2_PIN    BSP_IO_PORT_09_PIN_13

/* 读取引脚电平 */
#define INT_READ   	 PinRead(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_02)
#define KEY1_READ    PinRead(&g_ioport_ctrl, KEY1_SW1_PIN)
#define KEY2_READ    PinRead(&g_ioport_ctrl, KEY2_SW2_PIN)

/* 使用寄存器来实现 LED灯翻转 */
#define LED_TOGGLE R_PORT0->PODR ^= 1<<(BSP_IO_PORT_00_PIN_01 & 0xFF)



/* 按键扫描 */
uint8_t Key_Scan(uint8_t mode);

/* LED初始化函数 */
void GPIO_Init(void);

