/**
 ****************************************************************************************************
 * @file        myiic.h
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.0
 * @date        2021-10-23
 * @brief       IIC 
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ ̽ F407
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com
 * ˾ַ:www.alientek.com
 * ַ:openedv.taobao.com
 *
 * ޸˵
 * V1.0 20211023
 * һη
 *
 ****************************************************************************************************
 */
 
#ifndef __MYIIC_H
#define __MYIIC_H

#include "hal_data.h"
#include "bsp_gpio.h"
#include "delay_redefine.h"
#include "bsp_debug_uart.h"

/******************************************************************************************/

/* IO */
#define IIC_SCL(x)        do{ x ? \
                              SCL_HIGH : \
                              SCL_LOW; \
                          }while(0)       /* SCL */

#define IIC_SDA(x)        do{ x ? \
                              SDA_HIGH : \
                              SDA_LOW; \
                          }while(0)       /* SDA */

#define IIC_READ_SDA     PinRead(&g_ioport_ctrl, BSP_IO_PORT_04_PIN_01) /* ȡSDA */


/* IICв */
void iic_init(void);            /* ʼIICIO */
void iic_start(void);           /* IICʼź */
void iic_stop(void);            /* IICֹͣź */
void iic_ack(void);             /* IICACKź */
void iic_nack(void);            /* IICACKź */
uint8_t iic_wait_ack(void);     /* IICȴACKź */
void iic_send_byte(uint8_t txd);/* IICһֽ */
uint8_t iic_read_byte(unsigned char ack);/* IICȡһֽ */
void IIC_Read_One_Byte(uint8_t daddr,uint8_t addr,uint8_t* data);
void IIC_Write_One_Byte(uint8_t daddr,uint8_t addr,uint8_t data);
void IIC_ReadBytes(uint8_t deviceAddr, uint8_t writeAddr,uint8_t* data,uint8_t dataLength);

#endif

