#include "max30102.h"
#include "algorithm.h"
#include "lcd_init.h"
#include "lcd.h"
#include "AnoPTv8Test.h"
#include "bsp_adc.h"

uint8_t max30102_Bus_Write(uint8_t Register_Address, uint8_t Word_Data)
{

		/* ôEEPROM漴ȡָУȡֽ */

		/* 1I2Cź */
		iic_start();

		/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_WR);	/* ˴дָ */

		/* 3ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 4ֽڵַ */
		iic_send_byte(Register_Address);
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}
		
		/* 5ʼд */
		iic_send_byte(Word_Data);

		/* 6ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* I2Cֹͣź */
		iic_stop();
		return 1;	/* ִгɹ */

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
		/* I2Cֹͣź */
		iic_stop();
		return 0;
}



uint8_t max30102_Bus_Read(uint8_t Register_Address)
{
		uint8_t  data;


		/* 1I2Cź */
		iic_start();

		/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_WR);	/* ˴дָ */

		/* 3ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 4ֽڵַ */
		iic_send_byte((uint8_t)Register_Address);
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}
		

		/* 6I2Cߡ濪ʼȡ */
		iic_start();

		/* 7ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_RD);	/* ˴Ƕָ */

		/* 8ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 9ȡ */
		{
			data = iic_read_byte(0);	/* 1ֽ */

			iic_nack();	/* 1ֽڶCPUNACKź(SDA = 1) */
		}
		/* I2Cֹͣź */
		iic_stop();
		return data;	/* ִгɹ dataֵ */

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
		/* I2Cֹͣź */
		iic_stop();
		return 0;
}


void max30102_FIFO_ReadWords(uint8_t Register_Address,uint16_t  Word_Data[][2],uint8_t count)
{
		uint8_t i=0;
		uint8_t no = count;
		uint8_t data1, data2;
		/* 1I2Cź */
		iic_start();

		/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_WR);	/* ˴дָ */

		/* 3ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 4ֽڵַ */
		iic_send_byte((uint8_t)Register_Address);
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}
		

		/* 6I2Cߡ濪ʼȡ */
		iic_start();

		/* 7ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_RD);	/* ˴Ƕָ */

		/* 8ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 9ȡ */
		while (no)
		{
			data1 = iic_read_byte(0);	
			iic_ack();
			data2 = iic_read_byte(0);
			iic_ack();
			Word_Data[i][0] = (((uint16_t)data1 << 8) | data2);  //

			
			data1 = iic_read_byte(0);	
			iic_ack();
			data2 = iic_read_byte(0);
			if(1==no)
				iic_nack();	/* 1ֽڶCPUNACKź(SDA = 1) */
			else
				iic_ack();
			Word_Data[i][1] = (((uint16_t)data1 << 8) | data2); 

			no--;	
			i++;
		}
		/* I2Cֹͣź */
		iic_stop();

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
		/* I2Cֹͣź */
		iic_stop();
}

void max30102_FIFO_ReadBytes(uint8_t Register_Address,uint8_t* Data)
{	
		max30102_Bus_Read(REG_INTR_STATUS_1);
		max30102_Bus_Read(REG_INTR_STATUS_2);
		
		/* 1I2Cź */
		iic_start();

		/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_WR);	/* ˴дָ */

		/* 3ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 4ֽڵַ */
		iic_send_byte((uint8_t)Register_Address);
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}
		

		/* 6I2Cߡ濪ʼȡ */
		iic_start();

		/* 7ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
		iic_send_byte(max30102_WR_address | I2C_RD);	/* ˴Ƕָ */

		/* 8ACK */
		if (iic_wait_ack() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		/* 9ȡ */
		Data[0] = iic_read_byte(1);	
		Data[1] = iic_read_byte(1);	
		Data[2] = iic_read_byte(1);	
		Data[3] = iic_read_byte(1);
		Data[4] = iic_read_byte(1);	
		Data[5] = iic_read_byte(0);
		/* 1ֽڶCPUNACKź(SDA = 1) */
		/* I2Cֹͣź */
		iic_stop();

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
		/* I2Cֹͣź */
		iic_stop();
}

uint8_t max30102_init(void)
{	
		uint8_t part_id;
		iic_init();
		
		max30102_reset();	
	
		maxim_max30102_read_reg(REG_PART_ID, &part_id);
		printf("part_id:%d\r\n",part_id);
		if(part_id != 0x15)
		{
				return 1;
		}
		
		max30102_Bus_Write(REG_INTR_ENABLE_1,0xc0);	// ж   FIFOжϣFIFOݾжϣرջжϣԴ־ж
		max30102_Bus_Write(REG_INTR_ENABLE_2,0x10); // ڲ¶Ⱦ־ж   д0x02жϣ0x10ر

		max30102_Bus_Write(REG_FIFO_WR_PTR,0x00);  	// FIFO_WR_PTR[4:0]   FIFOдָõ0x00
		max30102_Bus_Write(REG_OVF_COUNTER,0x00);  	// OVF_COUNTER[4:0]   FIFO0üFIFOʱ¼ʧ
		max30102_Bus_Write(REG_FIFO_RD_PTR,0x00);  	// FIFO_RD_PTR[4:0]   FIFOָõ0x00
	
		max30102_Bus_Write(REG_FIFO_CONFIG,0x50);  	// FIFO Configuration  
		//sample avg = 1(ƽֵһʹõ)
		//fifo rollover=true(FIFOȫʱλFIFOΪTRUEFIFOַת㣬FIFOݡλδã0FIFO£ֱFIFO_DATAȡWRITE/READָλñı䡣)
		//fifo almost full = 32(ʣʱFIFOжϣFIFO洢32)
		
		max30102_Bus_Write(REG_MODE_CONFIG,0x03);  	// 0x02 ֻ, 0x03 ֻѪ 0x07 
		max30102_Bus_Write(REG_SPO2_CONFIG,0x27);  	// SPO2_ADC range = 2048nA, SPO2 sample rate (50 Hz), LED pulseWidth (69uS)  
	
		//LED      ֵ-1* 0.2 mA  ,0x24 = 36(ʮ)  36-1*0.2 = 7mA
		max30102_Bus_Write(REG_LED1_PA,0x24);   	  // Choose value for ~ 7mA for LED1      
		max30102_Bus_Write(REG_LED2_PA,0x24);   	  // Choose value for ~ 7mA for LED2
		
		//ӽģʽȣΪ0ӽģʽڼûָڼ׼
		max30102_Bus_Write(REG_PILOT_PA,0x00);   	  // Choose value for ~ 25mA for Pilot LED  


//		max30102_Bus_Write(REG_INTR_ENABLE_1,0xc0);	// ж   FIFOжϣFIFOݾжϣرջж
//		max30102_Bus_Write(REG_INTR_ENABLE_2,0x00); // رڲ¶Ⱦ־ж   д0x02жϣ0x10ر

//		max30102_Bus_Write(REG_FIFO_WR_PTR,0x00);  	// FIFO_WR_PTR[4:0]   FIFOдָõ0x00
//		max30102_Bus_Write(REG_OVF_COUNTER,0x00);  	// OVF_COUNTER[4:0]   FIFO0üFIFOʱ¼ʧ
//		max30102_Bus_Write(REG_FIFO_RD_PTR,0x00);  	// FIFO_RD_PTR[4:0]   FIFOָõ0x00
//	
//		max30102_Bus_Write(REG_FIFO_CONFIG,0x52);  	// FIFO Configuration  
//		//sample avg = 4 (ƽֵһʹõ)
//		//fifo rollover=true(FIFOȫʱλFIFOΪTRUEFIFOַת㣬FIFOݡλδã0FIFO£ֱFIFO_DATAȡWRITE/READָλñı䡣)
//		//fifo almost full = 30(ʣʱFIFOжϣFIFO洢32)
//		
//		max30102_Bus_Write(REG_MODE_CONFIG,0x03);  	// 0x02 ֻred, 0x03 redIR 0x07 redIR
//		
//			
//		
//		max30102_Bus_Write(REG_SPO2_CONFIG,0x27);  	// SPO2_ADC range = 4096nA, SPO2 sample rate (100 Hz), LED pulseWidth (411uS)  
//	
//		//LEDã   ֵ * 0.2 mA  ,0x3C = 60(ʮ)  60*0.2 = 12mA
//		max30102_Bus_Write(REG_LED1_PA,0x3C);   	  // Choose value for ~ 12mA for LED1      
//		max30102_Bus_Write(REG_LED2_PA,0x3C);   	  // Choose value for ~ 12mA for LED2
//		
//		//ӽģʽȣΪ0ӽģʽڼûָڼ׼
//		max30102_Bus_Write(REG_PILOT_PA,0x00);   	  // Choose value for ~ 25mA for Pilot LED  

		max30102_read_temp();     //һμ¶ģڳʼɺֱӼһΣټ¶ʱͲҪμ

		return 0;
}

void max30102_reset(void)
{
		while(max30102_Bus_Write(REG_MODE_CONFIG,0x40) != 1)
		{
				printf("reset failed...\r\n");
				delay_ms(1000);
		}
}

void maxim_max30102_write_reg(uint8_t uch_addr, uint8_t uch_data)
{
		IIC_Write_One_Byte(I2C_WRITE_ADDR,uch_addr,uch_data);
}

void maxim_max30102_read_reg(uint8_t uch_addr, uint8_t *puch_data)
{
		IIC_Read_One_Byte(I2C_WRITE_ADDR,uch_addr,puch_data);
}

void maxim_max30102_read_fifo(uint32_t *pun_red_led, uint32_t *pun_ir_led)
{
		uint32_t un_temp;
		unsigned char uch_temp;
		char ach_i2c_data[6];
		*pun_red_led=0;
		*pun_ir_led=0;

		
		//read and clear status register
		maxim_max30102_read_reg(REG_INTR_STATUS_1, &uch_temp);
		maxim_max30102_read_reg(REG_INTR_STATUS_2, &uch_temp);
		
		IIC_ReadBytes(I2C_WRITE_ADDR,REG_FIFO_DATA,(uint8_t *)ach_i2c_data,6);
		
		un_temp=(unsigned char) ach_i2c_data[0];
		un_temp<<=16;
		*pun_red_led+=un_temp;
		un_temp=(unsigned char) ach_i2c_data[1];
		un_temp<<=8;
		*pun_red_led+=un_temp;
		un_temp=(unsigned char) ach_i2c_data[2];
		*pun_red_led+=un_temp;
		
		un_temp=(unsigned char) ach_i2c_data[3];
		un_temp<<=16;
		*pun_ir_led+=un_temp;
		un_temp=(unsigned char) ach_i2c_data[4];
		un_temp<<=8;
		*pun_ir_led+=un_temp;
		un_temp=(unsigned char) ach_i2c_data[5];
		*pun_ir_led+=un_temp;
		*pun_red_led&=0x03FFFF;  //Mask MSB [23:18]
		*pun_ir_led&=0x03FFFF;  //Mask MSB [23:18]
}

float max30102_read_temp(void)
{
		int8_t tempInt;
		uint8_t tempFrac, response = 1;
		
		max30102_Bus_Write(REG_TEMP_CONFIG,0x01);
	
		while(response&0x01)
		{
				response = max30102_Bus_Read(REG_TEMP_CONFIG);
				delay_ms(10);
		}
	
		tempInt = max30102_Bus_Read(REG_TEMP_INTR);
		tempFrac = max30102_Bus_Read(REG_TEMP_FRAC);
	
		return (float)tempInt + ((float)tempFrac * 0.0625f);
}

float max30102_read_tempF(void) 	
{
  float temp = max30102_read_temp();

  if (temp != -999.0f) temp = temp * 1.8f + 32.0f;

  return (temp);
}

uint8_t max30102_read_sp02_PR(struct MAX30102 *max30102_data)
{
	uint32_t aun_ir_buffer[100];     //IR_LED
	uint32_t aun_red_buffer[100];    //HR_LED

	uint32_t n_sp02;                  //SPO2Ѫֵ
	int8_t ch_spo2_valid;            //ʾSP02ǷЧָʾ
	uint32_t n_heart_rate;            //ֵ
	int8_t  ch_hr_valid;             //ʾʼǷЧָʾ
	
	int i;                       //ѭʹ
	uint32_t un_min, un_max;     //red LED/Сֵ
	uint32_t ir_min, ir_max;     //ir LED/Сֵ
	uint8_t temp[6];
	
	uint8_t detection_number = 0;//
	uint8_t MAX_detection_number = 5;//
	
	uint8_t effective_detection_number = 0;//Ч
	uint8_t MAX_effective_detection_number = 1;//Ч
	
	max30102_data->vaild_value = 0;
		
	uint32_t spo2_value[5];
	uint32_t hr_value[5];
	
	LCD_Fill(0,22,LCD_W,LCD_H,BLACK);
	LCD_ShowString(16,26,"checking",YELLOW,BLACK,32,0);
	
	while(1)
	{		
		//
		un_min=0x3FFFF;
		un_max=0;
		ir_min=0x3FFFF;
		ir_max=0;
		
		//ȡǰ100ȷźŷΧ
		max30102_Bus_Write(REG_MODE_CONFIG,0x03);     //MAX30102Ϊģʽ
		for(i=0;i<max30102_data->n_ir_buffer_length;i++)
		{
			while(INT_READ==BSP_IO_LEVEL_HIGH);   //ȴֱжŴ
			
			max30102_FIFO_ReadBytes(REG_FIFO_DATA,temp);
			aun_red_buffer[i] =  (long)((long)((long)temp[0]&0x03)<<16) | (long)temp[1]<<8 | (long)temp[2];    // ֵԻʵ
			aun_ir_buffer[i] = (long)((long)((long)temp[3] & 0x03)<<16) |(long)temp[4]<<8 | (long)temp[5];     // ֵԻʵ/
            				
//			printf("red=%d\r\n",aun_red_buffer[i]);
//			printf("ir=%d\r\n",aun_ir_buffer[i]);
					
		}
		max30102_Bus_Write(REG_MODE_CONFIG,0x83);     //MAX30102Ϊģʽ     
		
		
		

		//ȼ⼸Σֵ൱ڽ⼸ȥ
		//⼸дǷǰݼԽǰΪֵеһݣԱ֤ݵȶ
		aun_red_buffer[0] = aun_red_buffer[5];
		aun_red_buffer[1] = aun_red_buffer[5];
		aun_red_buffer[2] = aun_red_buffer[5];
		
		aun_ir_buffer[0] = aun_ir_buffer[5];
		aun_ir_buffer[1] = aun_ir_buffer[5];
		aun_ir_buffer[2] = aun_ir_buffer[5];
		
//      //λ    //Сֵ
//		for(i=0;i<max30102_data->n_ir_buffer_length;i++)
//		{
//			if(un_min>aun_red_buffer[i])
//				un_min=aun_red_buffer[i];    //źСֵ
//			if(un_max<aun_red_buffer[i])
//				un_max=aun_red_buffer[i];    //źֵ
//		}
//		
//		
//		for(i=0;i<max30102_data->n_ir_buffer_length;i++)
//		{
//			if(ir_min>aun_ir_buffer[i])
//				ir_min=aun_ir_buffer[i];    //źСֵ
//			if(ir_max<aun_ir_buffer[i])
//				ir_max=aun_ir_buffer[i];    //źֵ
//		}	
		
		
/*
***λ***	
*/		
//		for(i=0;i<n_ir_buffer_length;i++)
//		{
//			printf("AAA%d",aun_red_buffer[i]-un_min);
////			printf("aun_red_buffer%d\r\n",aun_red_buffer[i]);
////			printf("un_min%d\r\n",un_min);
//			delay_ms(50);				
//		}	
//		for(i=0;i<n_ir_buffer_length;i++)
//		{
//			printf("AAA%d",aun_ir_buffer[i]-ir_min);
////			printf("aun_red_buffer%d\r\n",aun_red_buffer[i]);
////			printf("un_min%d\r\n",un_min);
//			delay_ms(50);				
//		}	

/*
***λ***	
*/	
//		for(i=0;i<n_ir_buffer_length;i++)
//		{			
//			AnoPTv8TxFrameF1_assistant(aun_ir_buffer[i]-ir_min, aun_red_buffer[i]-un_min);
//		}	

		//ǰ500ʺSpO2(ǰ5)
		maxim_heart_rate_and_oxygen_saturation(aun_ir_buffer, max30102_data->n_ir_buffer_length, aun_red_buffer, &n_sp02, &ch_spo2_valid, &n_heart_rate, &ch_hr_valid); 
		
//		printf("ch_spo2_valid:%d,n_sp02=%d\r\n",ch_spo2_valid,n_sp02);
//		printf("ch_hr_valid:%d,n_heart_rate=%d\r\n",ch_hr_valid,n_heart_rate);
		//delay_ms(1000);	
		
		detection_number++;                     //һ
		if(ch_spo2_valid & ch_hr_valid)         //ּͬʱЧݴ飬Чݱһ
		{
			spo2_value[effective_detection_number] = n_sp02;
			hr_value[effective_detection_number] = n_heart_rate;
			effective_detection_number++;
		}
		//ЧڵMAX_effective_detection_numberʱЧֵֵ˲Чֵֵ(1)һ
		if(effective_detection_number >= MAX_effective_detection_number)     
		{
			
			max30102_data->hr_value = 0;
			max30102_data->spo2_value = 0;
			//ֵ˲
			for(i = 0;i < effective_detection_number;i++)
			{
				max30102_data->hr_value += hr_value[i];
				max30102_data->spo2_value += spo2_value[i];
			}
			max30102_data->hr_value = max30102_data->hr_value/effective_detection_number;
			max30102_data->spo2_value = max30102_data->spo2_value/effective_detection_number;
			
			max30102_data->vaild_value = 1;
			return 1;
		}
		//MAX_detection_numberЧСMAX_effective_detection_numberʱЧֵֵ(0),0
		if(detection_number >= MAX_detection_number & effective_detection_number < MAX_effective_detection_number)         
		{			
			max30102_data->vaild_value = 0;
			return 0;
		}
				
	}
	
	return 0;
}

void max30102_read_temp_volt(struct MAX30102 *max30102_data)
{
	max30102_data->volt = 2 * Read_ADC_Voltage_Value();
	max30102_data->temp = max30102_read_temp();     
	max30102_data->temp_refresh_state = 1;
}
