#include "hal_data.h"
#include "bsp_debug_uart.h"
#include "bsp_gpio.h"
#include "max30102.h"
#include "algorithm.h"
#include "bsp_adc.h"
#include "lcd_init.h"
#include "lcd.h"
#include "oximeter.h"

FSP_CPP_HEADER
void R_BSP_WarmStart(bsp_warm_start_event_t event);
FSP_CPP_FOOTER

//ṹʼ
//Ѫֵ = 0, ֵ = 0, ֵǷЧֵ = 0, 峤 = 100, ¶ȼǷˢ״ֵ̬ = 0,  ¶ֵ = 0, ѹֵ = 0
struct MAX30102 max30102_check = {0, 0, 0, 100, 0, 0, 0};

fsp_err_t err = FSP_SUCCESS;
/*******************************************************************************************************************//**
 * main() is generated by the RA Configuration editor and is used to generate threads if an RTOS is used.  This function
 * is called by main() when no RTOS is used.
 **********************************************************************************************************************/
void hal_entry(void)
{    
	uint8_t key;
	uint8_t lcd_state = 0;                      //LCD״̬0ʾѪ棬1ʾ¶Ⱥ͵

	GPIO_Init();         //ųʼ
	Debug_UART9_Init();  //ʼ9115200RASCã
	ADC_Init();			 //ADCʼ
	LCD_Init();			 //LCDʼ
	
	printf("max30102_init:%d\r\n",max30102_init());	
	
	while(1)
	{			
		//printf("Read_ADC_Voltage_Value:%f\r\n",Read_ADC_Voltage_Value());     //صѹ
		
		key = Key_Scan(0);		
		
		chedk_fuc(&max30102_check, key, &lcd_state);
		
		LED_show_main(&max30102_check, lcd_state);
		
		
	}
	
#if BSP_TZ_SECURE_BUILD
    /* Enter non-secure code */
    R_BSP_NonSecureEnter();
#endif

}

/*******************************************************************************************************************//**
 * This function is called at various points during the startup process.  This implementation uses the event that is
 * called right before main() to set up the pins.
 *
 * @param[in]  event    Where at in the start up process the code is currently at
 **********************************************************************************************************************/
void R_BSP_WarmStart (bsp_warm_start_event_t event)
{
    if (BSP_WARM_START_RESET == event)
    {
#if BSP_FEATURE_FLASH_LP_VERSION != 0

        /* Enable reading from data flash. */
        R_FACI_LP->DFLCTL = 1U;

        /* Would normally have to wait tDSTOP(6us) for data flash recovery. Placing the enable here, before clock and
         * C runtime initialization, should negate the need for a delay since the initialization will typically take more than 6us. */
#endif
    }

    if (BSP_WARM_START_POST_C == event)
    {
        /* C runtime environment and system clocks are setup. */

        /* Configure pins. */
        R_IOPORT_Open(&g_ioport_ctrl, &IOPORT_CFG_NAME);
    }
}

#if BSP_TZ_SECURE_BUILD

FSP_CPP_HEADER
BSP_CMSE_NONSECURE_ENTRY void template_nonsecure_callable ();

/* Trustzone Secure Projects require at least one nonsecure callable function in order to build (Remove this if it is not required to build). */
BSP_CMSE_NONSECURE_ENTRY void template_nonsecure_callable ()
{

}
FSP_CPP_FOOTER

#endif
