#include "lcd.h"
#include "lcd_init.h"
#include "oximeter.h"
#include "bsp_adc.h"

void chedk_fuc(struct MAX30102 *max30102_data_ori, uint8_t key, uint8_t *lcd_state)
{
	struct MAX30102 max30102_data = *max30102_data_ori;
	if(key == 1 & *lcd_state == 0)               //KEY1LCD״̬Ϊ0ʱʼѪ
	{
		max30102_read_sp02_PR(&max30102_data);
		if(max30102_data.vaild_value != 1)
		{
			LCD_Fill(0,22,LCD_W,LCD_H,BLACK);
			LCD_ShowString(40,26,"error",RED,BLACK,32,0);
		}
	}
	else if(key == 1 & *lcd_state == 1) 			//KEY1LCD״̬Ϊ1ʱһεѹ¶
	{
		max30102_read_temp_volt(&max30102_data);
	}			
	else if(key == 2)        //KEY2£лʾ״̬
	{
		if(*lcd_state)
			*lcd_state = 0;
		else
			*lcd_state =1;
		
		LCD_Fill(0,0,LCD_W,LCD_H,BLACK);                  //ֱˢʾ
		
		if(*lcd_state)
		{
			LCD_ShowString(30,6,"temp",WHITE,BLACK,12,0);
			LCD_ShowString(100,6,"volt",WHITE,BLACK,12,0);
			LCD_ShowString(28,26,"--",WHITE,BLACK,32,0);
			LCD_ShowString(100,26,"--",WHITE,BLACK,32,0);
			max30102_read_temp_volt(&max30102_data);
		}
		else
		{
			LCD_ShowString(30,6,"%sp02",WHITE,BLACK,12,0);
			LCD_ShowString(100,6,"PR bpm",WHITE,BLACK,12,0);
			LCD_ShowString(28,26,"--",WHITE,BLACK,32,0);
			LCD_ShowString(100,26,"--",WHITE,BLACK,32,0);
		}			
	}
	*max30102_data_ori = max30102_data;
}

void LED_show_main(struct MAX30102 *max30102_data_ori, uint8_t lcd_state)
{
	float volt;
	uint8_t count = 1;
	if(max30102_data_ori->vaild_value && lcd_state == 0)
	{
		LCD_Fill(0,22,LCD_W,LCD_H,BLACK);
		LCD_ShowIntNum(29,26,max30102_data_ori->spo2_value,2,WHITE,BLACK,32);
		if(max30102_data_ori->hr_value < 100)
		{
			LCD_ShowIntNum(101,26,max30102_data_ori->hr_value,2,WHITE,BLACK,32);
		}
		else if(max30102_data_ori->hr_value >= 100)
			LCD_ShowIntNum(93,26,max30102_data_ori->hr_value,3,WHITE,BLACK,32);
	} 
	if(max30102_data_ori->temp_refresh_state && lcd_state == 1)
	{
		LCD_Fill(0,22,LCD_W,LCD_H,BLACK);
		LCD_ShowFloatNum1(13,26,max30102_data_ori->temp,4,WHITE,BLACK,24);
		LCD_ShowFloatNum1(90,26,max30102_data_ori->volt,3,WHITE,BLACK,24);
	}
	   
	if(count%5 == 1)                 //൱ѭ5һγ״̬
	{
		volt = 2 * Read_ADC_Voltage_Value();
		if(volt > 4.35)
			LCD_ShowString(150,6,"C",GREEN,BLACK,12,0);
		else
			LCD_Fill(150,6,160,20,BLACK);  
		count = 1;
	}
	count++;
	max30102_data_ori->vaild_value = 0;         //ֹĻˢ
	max30102_data_ori->temp_refresh_state = 0;  
}
